<?php
include($O__libPath . "/functions/server/O__backupData.php");

// Load settings
$O__fileData = O__XMLdata($O__DBpath . "/pageTypes/" . $O__PT . "/configs/settings.xml", 0, 0);
$O__pathData = $O__DBpath . "/pageTypes/" . $O__PT . "/data";
$O__pathHeads = $O__DBpath . "/pageTypes/" . $O__PT . "/heads";
$O__pathAreas = $O__DBpath . "/pageTypes/" . $O__PT . "/areas";
unset($O__fileData);

$O__PTATmsg = "";
$O__page = $O__URLpath[1];

function O__operation(){
	global $O__DBpath, $O__PTATmsg, $O__logNotes, $O__page, $O__pathData, $O__pathHeads, $O__pathAreas;
	
	$O__PTATmsgAddendum = "";
	$O__operation = $_POST["O__operation"];
	
	switch($O__operation){
		case "save":
			$O__published = $_POST["O__published"];
			
			// Set up XML DOM with submitted values
			$O__fileData = new DomDocument("1.0", "UTF-8");
			$O__pageInfo = $O__fileData->createElement("page", "");
				$O__pageInfo->appendChild($O__fileData->createElement("published", $O__published));
				$O__pageInfo->appendChild($O__fileData->createElement("title", htmlspecialchars($_POST["O__title"])));
				$O__fileData->appendChild($O__pageInfo);				
				
				$O__pageInfo->appendChild($O__fileData->createElement("summary", htmlspecialchars($_POST["O__summary"])));		
				$O__pageInfo->appendChild($O__fileData->createElement("bodyCopy", htmlspecialchars($_POST["O__bodyCopy"])));
				$O__pageInfo->appendChild($O__fileData->createElement("URLtitle", htmlspecialchars($_POST["O__URLtitle"])));
				
				$O__metadata = $O__fileData->createElement("metadata", "");
					$O__metadata->appendChild($O__fileData->createElement("title", htmlspecialchars($_POST["O__metadataTitle"])));
					$O__metadata->appendChild($O__fileData->createElement("description", htmlspecialchars($_POST["O__metadataDescription"])));
					$O__metadata->appendChild($O__fileData->createElement("keywords", $_POST["O__metadataKeywords"]));
					$O__pageInfo->appendChild($O__metadata);
				
				$O__opengraph = $O__fileData->createElement("opengraph", "");
					$O__opengraph->appendChild($O__fileData->createElement("title", htmlspecialchars($_POST["O__opengraphTitle"])));
					$O__opengraph->appendChild($O__fileData->createElement("description", htmlspecialchars($_POST["O__opengraphDescription"])));
					$O__opengraph->appendChild($O__fileData->createElement("img", htmlspecialchars($_POST["O__opengraphImg"])));
					$O__opengraph->appendChild($O__fileData->createElement("URL", htmlspecialchars($_POST["O__opengraphURL"])));
					$O__opengraph->appendChild($O__fileData->createElement("sitename", htmlspecialchars($_POST["O__opengraphSitename"])));
					$O__pageInfo->appendChild($O__opengraph);

			$O__fileData->appendChild($O__pageInfo); // add tree to root XML
						
			// Backup old data and save new one
			O__backupData($O__pathData . "/" . $O__page . ".xml",0);
			O__XMLdata($O__pathData . "/" . $O__page . ".xml", $O__fileData, 0);
			unset($O__fileData);
			clearstatcache(); // clear cache so newest version can be loaded
			
			// Take steps to publish/unpublish
			if ($O__published == 1) {
				// publish head
				$O__fileData = "<title>" . $_POST["O__metadataTitle"] . "</title>\n";
				$O__fileData .= "<meta name=\"description\" content=\"" . $_POST["O__metadataDescription"] . "\"> \n";
				$O__fileData .= "<meta name=\"keywords\" content=\"" . $_POST["O__metadataKeywords"] . "\">\r\n";
				$O__fileData .= "<meta property=\"og:url\" content=\"" . $_POST["O__opengraphURL"] . "\" />\r\n";
				$O__fileData .= "<meta property=\"og:type\" content=\"website\" />\n";
				$O__fileData .= "<meta property=\"og:title\" content=\"" . $_POST["O__opengraphTitle"] . "\" />\n";
				$O__fileData .= "<meta property=\"og:description\" content=\"" . $_POST["O__opengraphDescription"] . "\" />\r\n";
				$O__fileData .= "<meta property=\"og:image\" content=\"" . $_POST["O__opengraphImg"] . "\" />\r\n";
				O__dataWrite($O__pathHeads . "/" . $O__page . ".php",$O__fileData);
				unset($O__fileData);

				// publish area
				$O__fileData = "";
				$O__fileData .= "<h1>" . $_POST["O__title"] . "</h1>\n";
				$O__fileData .= "<div id=\"O__pageSummary\">" . $_POST["O__summary"] . "</div>\n";
				$O__fileData .= "<div id=\"O__pageBody\">" . $_POST["O__bodyCopy"] . "</div>\n";
				O__dataWrite($O__pathAreas . "/" . $O__page . ".php",$O__fileData);
				unset($O__fileData);		
				
				$O__PTATmsgAddendum .= " Page is PUBLISHED.";
			} else if ($O__published == 0) {
				
				//delete head
				if (file_exists($O__pathHeads . "/" . $O__page . ".php")){ unlink($O__pathHeads . "/" . $O__page . ".php"); }
				
				// delete area
				if (file_exists($O__pathAreas . "/" . $O__page . ".php")){ unlink($O__pathAreas . "/" . $O__page . ".php"); }
				
				$O__PTATmsgAddendum .= " Page is NOT published.";
			}

			break;
	}
	
	// System message and logging
	
	$O__sysMsgHeadline = "Save Page";
	$O__sysMsgBody = "Success. '" . $O__page . "' has been updated. " . $O__PTATmsgAddendum;
	$O__PTATmsg = O__sysMsg($O__sysMsgHeadline, $O__sysMsgBody, "O__sysMsgNeutral");
	$O__logNotes .= $O__sysMsgHeadline . ". " . $O__sysMsgBody;

}

function O__createOutput(){
	global $O__DBpath, $O__PTATmsg, $O__pathData, $O__page, $O__PT;
	
	// Load source data
	$O__fileData = O__XMLdata($O__pathData . "/" . $O__page. ".xml", 0, 0);
	$O__published = $O__fileData->published;
	$O__title = $O__fileData->title;
	$O__summary = $O__fileData->summary;
	$O__bodyCopy = $O__fileData->bodyCopy;
	$O__URLtitle = $O__fileData->URLtitle;
	$O__metadataTitle = $O__fileData->metadata->title;
	$O__metadataDescription = $O__fileData->metadata->description;
	$O__metadataKeywords = $O__fileData->metadata->keywords;
	$O__opengraphTitle = $O__fileData->opengraph->title;
	$O__opengraphDescription = $O__fileData->opengraph->description;
	$O__opengraphImg = $O__fileData->opengraph->img;
	$O__opengraphURL = $O__fileData->opengraph->URL;
	$O__opengraphSitename = $O__fileData->opengraph->sitename;
		
	// Create UI output	
	$O__output = "<h2>Pages</h2>";
	$O__output .= "<b>Now editing:</b> '" . $O__page . "'";
	$O__output .= $O__PTATmsg;
	$O__output .= "<form name=\"O__pageForm\" id=\"O__pageForm\" action=\"/" . $O__PT . "/" . $O__page . "/edit\" method=\"post\">";
	$O__output .= "<input type=\"hidden\" name=\"O__operation\" value=\"\">";
	$O__output .= "<input type=\"hidden\" name=\"O__URLtitle\" value=\"" . $O__URLtitle ."\">";
	
	if (isset($_SERVER["HTTPS"])) { $O__serverProtocol = "https://"; } else { $O__serverProtocol = "http://"; }
	$O__output .= "<p><b>URL</b><br><a href=\"" . $O__serverProtocol . $_SERVER["HTTP_HOST"] . "/" . $O__PT . "/" . $O__page . "/display\" target=\"_new\">" . $O__serverProtocol . $_SERVER["HTTP_HOST"] . "/" . $O__PT . "/" . $O__page. "/display</a></p>";
	
	$O__output .= "<p><b>Published:</b><br>";
	$O__output .= "<select name=\"O__published\">";
	$O__output .= "<option value=\"0\"";
		if ($O__published == 0) { $O__output .= " selected"; }	
	$O__output .=  ">No</option>";
	$O__output .= "<option value=\"1\"";
		if ($O__published == 1) { $O__output .= " selected"; }	
	$O__output .= ">Yes</option>";
	$O__output .=  "</select>";

	$O__output .= "<p><b>Title</b><br><input type=\"text\" name=\"O__title\" value=\"" . $O__title . "\"></p>";
	
	$O__output .= "<p><b>Summary</b><br><textarea style=\"width:98%;\" name=\"O__summary\" class=\"O__itemInfo\" >" . $O__summary . "</textarea></p>";
	$O__output .= "<p><b>Body</b><br><textarea style=\"width:98%;\" rows=\"25\" name=\"O__bodyCopy\" id=\"O__bodyCopy\" class=\"O__itemInfo\" >" . $O__bodyCopy . "</textarea></p>";
	
	$O__output .= "<h2>Metadata</h2>";
	$O__output .= "<p><b>Title</b><br><input type=\"text\" name=\"O__metadataTitle\" value=\"" . $O__metadataTitle . "\"></p>";
	$O__output .= "<p><b>Description</b><br><input type=\"text\" name=\"O__metadataDescription\" value=\"" . $O__metadataDescription . "\"></p>";
	$O__output .= "<p><b>Keywords</b><br><input type=\"text\" name=\"O__metadataKeywords\" value=\"" . $O__metadataKeywords . "\"></p>";
		
	$O__output .= "<h2>Open Graph</h2>";
	$O__output .= "<p><b>Title</b><br><input type=\"text\" name=\"O__opengraphTitle\" value=\"" . $O__opengraphTitle . "\"></p>";
	$O__output .= "<p><b>Description</b><br><input type=\"text\" name=\"O__opengraphDescription\" value=\"" . $O__opengraphDescription . "\"></p>";
	$O__output .= "<p><b>Image</b><br><input type=\"text\" name=\"O__opengraphImg\" value=\"" . $O__opengraphImg . "\"></p>";
	$O__output .= "<p><b>Page URL</b><br><input type=\"text\" name=\"O__opengraphURL\" value=\"" . $O__opengraphURL . "\"></p>";
	$O__output .= "<p><b>Site Name</b><br><input type=\"text\" name=\"O__opengraphSitename\" value=\"" . $O__opengraphSitename . "\"></p>";
	
	$O__output .="<a href=\"#\" onclick=\"javascript:O__operation('save')\">Save Page</a>";
	$O__output .= "</form>";

	return $O__output;
}

if(isset($_POST["O__operation"])){ O__operation(); }
$O__output = O__createOutput();
?>

<script>
function O__operation(O__action){
	var O__form = document.forms["O__pageForm"];
	O__form.O__operation.value = O__action;
	O__form.submit();
}
</script>
